#pragma once

#include <stm32f4xx_hal_def.h>
#include <stm32f4xx_hal.h>

// Konstanten fr den Frequenzteiler
enum class UrsAdcClockDivider {
   Div2 = ADC_CLOCK_SYNC_PCLK_DIV2,
   Div4 = ADC_CLOCK_SYNC_PCLK_DIV4,
   Div6 = ADC_CLOCK_SYNC_PCLK_DIV6,
   Div8 = ADC_CLOCK_SYNC_PCLK_DIV8
};

// Konstanten fr die Auflsung
enum class UrsAdcResolution {
   Bit12 = ADC_RESOLUTION_12B,
   Bit10 = ADC_RESOLUTION_10B,
   Bit8 = ADC_RESOLUTION_8B,
   Bit6 = ADC_RESOLUTION_6B
};

// Konstanten fr die Auslsung des ADC-EOC-Interrupts.
enum class UrsAdcEocSelection {
   // The EOC bit is set at the end of each sequence of regular conversions.
   Sequence = ADC_EOC_SEQ_CONV << ADC_CR2_EOCS_Pos,
   // The EOC bit is set at the end of each regular conversion.
   Single = ADC_EOC_SINGLE_CONV << ADC_CR2_EOCS_Pos
};

// Konstanten fr die Konvertierungszeit pro Kanal
enum class UrsAdcSampleTime {
   Cycles_3,
   Cycles_15,
   Cycles_28,
   Cycles_56,
   Cycles_84,
   Cycles_112,
   Cycles_144,
   Cycles_480
};

// Konstanten fr die Einlesekanle
enum class UrsAdcChannel {
   // Beim Black Pill sind nur die Kanle 0..9 heraus gefhrt.
   // PA0..PA1, PB0, PBB1
   Channel0 = ADC_CHANNEL_0,
   Channel1 = ADC_CHANNEL_1,
   Channel2 = ADC_CHANNEL_2,
   Channel3 = ADC_CHANNEL_3,
   Channel4 = ADC_CHANNEL_4,
   Channel5 = ADC_CHANNEL_5,
   Channel6 = ADC_CHANNEL_6,
   Channel7 = ADC_CHANNEL_7,
   Channel8 = ADC_CHANNEL_8,
   Channel9 = ADC_CHANNEL_9,
   Vbat = ADC_CHANNEL_VBAT
};

/*
enum class UrsAdcTrigger {
   // CC   = Capture Compare Event
   // TRGO = Trigger Out Event
   T1CC1 = ADC_EXTERNALTRIGCONV_T1_CC1 << ADC_CR2_EXTSEL_Pos,
   T1CC2 = ADC_EXTERNALTRIGCONV_T1_CC2 << ADC_CR2_EXTSEL_Pos,
   T1CC3 = ADC_EXTERNALTRIGCONV_T1_CC3 << ADC_CR2_EXTSEL_Pos,
   T2CC2 = ADC_EXTERNALTRIGCONV_T2_CC2 << ADC_CR2_EXTSEL_Pos,
   T2CC3 = ADC_EXTERNALTRIGCONV_T2_CC3 << ADC_CR2_EXTSEL_Pos,
   T2CC4 = ADC_EXTERNALTRIGCONV_T2_CC4 << ADC_CR2_EXTSEL_Pos,
   T2_TRGO = ADC_EXTERNALTRIGCONV_T2_TRGO << ADC_CR2_EXTSEL_Pos,
   T3_CC1 = ADC_EXTERNALTRIGCONV_T3_CC1 << ADC_CR2_EXTSEL_Pos,
   T3_TRGO = ADC_EXTERNALTRIGCONV_T3_TRGO << ADC_CR2_EXTSEL_Pos,
   T4_CC4 = ADC_EXTERNALTRIGCONV_T4_CC4 << ADC_CR2_EXTSEL_Pos,
   T5_CC1 = ADC_EXTERNALTRIGCONV_T5_CC1 << ADC_CR2_EXTSEL_Pos,
   T5_CC2 = ADC_EXTERNALTRIGCONV_T5_CC2 << ADC_CR2_EXTSEL_Pos,
   T5_CC3 = ADC_EXTERNALTRIGCONV_T5_CC3 << ADC_CR2_EXTSEL_Pos,
   T8_CC1 = ADC_EXTERNALTRIGCONV_T8_CC1 << ADC_CR2_EXTSEL_Pos,
   T8_TRGO = ADC_EXTERNALTRIGCONV_T8_TRGO << ADC_CR2_EXTSEL_Pos,
   Ext_IT11 = ADC_EXTERNALTRIGCONV_Ext_IT11 << ADC_CR2_EXTSEL_Pos,
   Software = ADC_SOFTWARE_START // Kein Trigger
};

*/